/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 02.03.2013
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 1,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

#define RED OCR2
#define GREEN OCR1B
#define BLUE OCR1A
#define CLOCK PORTC.0
#define DATA  PORTC.1
#define LATCH PORTC.2
#define OE    PORTC.3


char red[16],green[16],blue[16],LED,i,Enter_LED,M=1,sw2_state,sw1_state;

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{ //TCNT0=165;
// Place your code here

for(i=0; i<=15; i++ ) 
    { 
       if(LED==i)  
            { 
             DATA = 1;
             
            } 
       else 
             { 
             DATA = 0; 
             };
              CLOCK = 1;   //   
              CLOCK = 0; 
     };      
             
             OE=1;  //  ,           
             
             LATCH = 1;  //    
             LATCH = 0;
             RED=red[LED];
             GREEN=green[LED];
             BLUE=blue[LED]; 
             OE = 0; //  . 
     LED++;
     if (LED>15) LED=0;  
              
             
      
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0b11111111;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0xff;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=T State3=T State2=T State1=T State0=T 
PORTD=0xff;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
TCCR0=0x02;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Fast PWM top=0x00FF
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xA1;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x69;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;
#asm("sei")
while (1)
      {
      // Place your code here
      
     
     if ((PIND.5==0)&&(sw1_state==0)) {Enter_LED++;sw1_state=1;PORTB.0^=1;}; 
     if ((PIND.5==1)&&(sw1_state==1)) sw1_state=0;
     if (Enter_LED>15) Enter_LED=0;
     
     if (PIND.6==0)
       {  sw2_state=1;PORTB.0^=1;
          switch (M) 
          {
            case 1: red[Enter_LED]++; if (red[Enter_LED]==255) M=2;break;
            case 2: green[Enter_LED]++; if (green[Enter_LED]==255) M=3; break;
            case 3: red[Enter_LED]--; if (red[Enter_LED]==0) M=4; break;
            case 4: blue[Enter_LED]++; if (blue[Enter_LED]==255) M=5; break;
            case 5: green[Enter_LED]--; if (green[Enter_LED]==0) M=6; break;
            case 6: red[Enter_LED]++; if (red[Enter_LED]==255) M=7; break;
            case 7: blue[Enter_LED]--; if (blue[Enter_LED]==0) M=8;  break;
            case 8: red[Enter_LED]--; if (red[Enter_LED]==0) M=9; break;
            case 9: red[Enter_LED]++;green[Enter_LED]++;blue[Enter_LED]++; if ((red[Enter_LED]==255)&&(green[Enter_LED]==255)&&(blue[Enter_LED]==255)) M=10; break;
            case 10: red[Enter_LED]--;green[Enter_LED]--;blue[Enter_LED]--; if ((red[Enter_LED]==0)&&(green[Enter_LED]==0)&&(blue[Enter_LED]==0)) M=1;break;   
          };
          
      };  
      if ((PIND.6==1)&&(sw2_state==1)) sw2_state=0;
      delay_ms(5);
     
           
     
     
      }
}
